START TRANSACTION ;

-- --------------------------------------------------------

--
-- Структура таблицы `study_form`
--
CREATE TABLE IF NOT EXISTS `study_form` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `FormName` varchar(40) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `FormName` (`FormName`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

--
-- Структура таблицы `record_books`
--
CREATE TABLE IF NOT EXISTS `record_books` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `StudentID` int(11) NOT NULL,
  `ExternalID` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `PlanID` int(11) NOT NULL,
#   `Speciality` int (11) NOT NULL, -- in specializations
#   `Form` int(11) NOT NULL, -- in study_groups
#   `Subdivision` int(11) NOT NULL, -- in study_groups
#   `Grade` int(11) NOT NULL, -- in study_groups
#   `Group` int(11) NOT NULL, -- in study_groups
  PRIMARY KEY (`ID`),
  UNIQUE KEY `ExternalID` (`ExternalID`),
  KEY `StudentID` (`StudentID`),
  KEY `PlanID` (`PlanID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

--
-- Структура таблицы `study_plans`
--
CREATE TABLE IF NOT EXISTS `study_plans` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `ExternalID` int(11) NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `ExternalID` (`ExternalID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

--
-- Структура таблицы `disciplines_exam_type`
--
CREATE TABLE IF NOT EXISTS `disciplines_exam_type` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `ExamTypeName` varchar(40) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `ExamTypeName` (`ExamTypeName`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

--
-- Исправления таблиц
--

### Мигрируем уровни обучения
# ALTER TABLE `grades`
#   ADD COLUMN `DegreeID` int(11) AFTER `Num`; # ToDo: should be NOT NULL

# ToDo: move data from DegreeToDegreeID

# ALTER TABLE `grades`
#   DROP COLUMN `Degree`;

### Переводим стрелки со студентов на их зачетки
# ALTER TABLE `students_groups`
#   DROP FOREIGN KEY `students_groups_ibfk_1`,
#   DROP KEY `StudentID`,
#   DROP KEY `StudentID_2`;
#

###
#
# ALTER TABLE `rating_table`
#   CHANGE COLUMN `StudentID` `RecordBookID` int(11) NOT NULL;
#
# ### Добавляем ссылки на новые таблицы
ALTER TABLE `study_groups`
  ADD COLUMN `FormID` int(11) AFTER `FacultyID`;
-- ToDo: FormID should be NOT NULL

ALTER TABLE `subjects`
  ADD COLUMN `ExternalID` varchar(40) CHARACTER SET utf8 DEFAULT '' AFTER `ID`,
  ADD COLUMN `TypeID` int(11) DEFAULT -1 AFTER `ExternalID`;
-- ToDo: TypeID should be NOT NULL


COMMIT ;